//+------------------------------------------------------------------+
//|                                                       vladds.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
extern double lots=0.1;
extern int    magic          = 457546456; 
extern int tip=1;
extern int TakeProfit=30;
extern int StopLoss=30;
extern double Martin=1;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
if(Digits==5 || Digits==3)
     {
      TakeProfit  *=10;
      StopLoss    *=10;
      
     }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
double Spred =Ask-Bid;
  Comment(GetLossLastPosRynok(),GetProfitLastPosRynok());
if(CountHistori()==0 && CountVsego()==0 ){
if(tip==1){
OrderSend(Symbol(),OP_BUY,lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"",magic,0,clrGreen);
}
if(tip==2){
OrderSend(Symbol(),OP_SELL,lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"",magic,0,clrRed);
}
}
if(CountBUY()==1 && CountSELL()==0 && CountBUYstop()==0 && CountSellStop()==0){
OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(GetLotLastPosRynok()*Martin,2),GetLossLastPosRynok()-Spred,5,GetLossLastPosRynok()-Spred+StopLoss*Point,GetLossLastPosRynok()-Spred-TakeProfit*Point,"",magic,0,clrGreen);
OrderSend(Symbol(),OP_BUYSTOP,lots,GetProfitLastPosRynok()+Spred,5,GetProfitLastPosRynok()+Spred-StopLoss*Point,GetProfitLastPosRynok()+Spred+TakeProfit*Point,"",magic,0,clrGreen);
}

if(CountBUYstop()==1 && CountSellStop()==0){
DeleteOrdersOP_BUYSTOP();
}

if(CountBUYstop()==0 && CountSellStop()==1){
DeleteOrdersOP_SELLSTOP();
}
if(CountBUY()==0 && CountSELL()==1 && CountBUYstop()==0 && CountSellStop()==0){
OrderSend(Symbol(),OP_SELLSTOP,lots,GetProfitLastPosRynok()-Spred,5,GetProfitLastPosRynok()-Spred+StopLoss*Point,GetProfitLastPosRynok()-Spred-TakeProfit*Point,"",magic,0,clrGreen);
OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(GetLotLastPosRynok()*Martin,2),GetLossLastPosRynok()+Spred,5,GetLossLastPosRynok()+Spred-StopLoss*Point,GetLossLastPosRynok()+Spred+TakeProfit*Point,"",magic,0,clrGreen);
}
   
  }
//+------------------------------------------------------------------+

int CountSELL()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
int CountBUY()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountVsego()
  {
   int Vsego;
   Vsego=CountBUY()+CountSELL();

   return(Vsego);
  }
  
  int CountHistori()
  {
   int count=0;
   int i;
   for(i=OrdersHistoryTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY ))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic )
         if( OrderType()==OP_BUY|| OrderType()==OP_SELL){
            count++;
            }
        }
     }
   return(count);
  }
  
  //+------------------------------------------------------------------+
//         
//+------------------------------------------------------------------+
double GetLossLastPosRynok(string sy="", int op=-1, int mn=-1) {
  datetime o;
  double   l=-1;
  int      i, k=OrdersTotal();
  
  

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==magic) {
              if (o<OrderOpenTime()) {
                o=OrderOpenTime();
                l=OrderStopLoss();
              }
            }
          }
        }
      }
    }
  }
  return(NormalizeDouble(l, Digits));
}

double GetProfitLastPosRynok(string sy="", int op=-1, int mn=-1) {
  datetime o;
  double   l=-1;
  int      i, k=OrdersTotal();
  
  

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==magic) {
              if (o<OrderOpenTime()) {
                o=OrderOpenTime();
                l=OrderTakeProfit();
              }
            }
          }
        }
      }
    }
  }
  return(NormalizeDouble(l, Digits));
}

int CountSellStop()
{
  int count=0;
  
  for( int pos=0;pos<OrdersTotal();pos++)
  {
    if (OrderSelect(pos,SELECT_BY_POS ,MODE_TRADES))
      {
       if( OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELLSTOP)
       count++;
      }
   }
  return(count);
} 

int CountBUYstop()
{
  int count=0;
  
  for( int pos=0;pos<OrdersTotal();pos++)
  {
    if (OrderSelect(pos,SELECT_BY_POS ,MODE_TRADES))
      {
       if( OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUYSTOP)
       count++;
      }
   }
  return(count);
}

 void DeleteOrdersOP_BUYSTOP(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int err, i, it, k=OrdersTotal(), ot;
  
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==OP_BUYSTOP)) {
          if (mn<0 || OrderMagicNumber()==magic) {
            
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), CLR_NONE);
              
            }
          }
        }
      }
    }
  }
/////////////////////////////////////////////////////////////////////////////////////////
void DeleteOrdersOP_SELLSTOP(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int err, i, it, k=OrdersTotal(), ot;
  
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==OP_SELLSTOP)) {
          if (mn<0 || OrderMagicNumber()==magic) {
            
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), CLR_NONE);
              
            }
          }
        }
      }
    }
  }
  
  double GetLotLastPosRynok(string sy="", int op=-1, int mn=-1) {
  datetime o;
  double   l=-1;
  int      i, k=OrdersTotal();
  
  

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==magic) {
              if (o<OrderOpenTime()) {
                o=OrderOpenTime();
                l=OrderLots();
              }
            }
          }
        }
      }
    }
  }
  return(l);
}  

